% Analysis Operator Learning for the Piecewise Constant Images
% The Shepp-Logan phantom was used for trainig
% A full rank operator is seeking in a noiseless setting.

% Constrained Analysis Operator Learning for Cosparse Signal Modelling
% Written by Mehrdad Yaghoobi, version 1.0                                    
%     
% Copyright 2013 Mehrdad Yaghoobi, Sangnam Nam, Remi Gribonval and Mike E. Davies
% 
% For all details please refer to README.m
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence, for 
% personal and non-commercial use and research purpose. 

M = 64; % Signal Dimensiona (8 by 8 image patches)
N = 128; % Analysis Space Dimension
L = 128*N; % Number of Training Samples
ParamGenPSI(M,N,L) % Trainig Data and Initial Operator Generation

%%% Analysis 0perator Learning
 
SubGPAOLImageRand(M,N,L);

%%% Showing the Result

% load ImageAOL64X128X16384.mat % Loading the Simulation Results
load(['ImageAOL',num2str(M),'X',num2str(N),'X',num2str(L),'.mat'])

subplot(121)
Do = makingpositive(Do); 
Omgo = Rowshow(Do,256);
imagesc(Omgo)
axis image
colormap(gray(256))
set(gca,'XTick',[],'YTick',[])
title('Original Operator')

subplot(122)
D = makingpositive(D);
Omg = Rowshow(D,256);
imagesc(Omg)
axis image
colormap(gray(256))
set(gca,'XTick',[],'YTick',[])
title('Learned Operator')
