function [] = SubGPAOLImageRand(M,N,L)
% Projected Sub Gradient Analysis Operator Learning With the Fixed Small Step-size
% M = Signal space dimension
% N = Analysis space dimension
% L = Population of the training samples

% Constrained Analysis Operator Learning for Cosparse Signal Modelling
% Written by Mehrdad Yaghoobi, version 1.0                                    
%     
% Copyright 2013 Mehrdad Yaghoobi, Sangnam Nam, Remi Gribonval and Mike E. Davies
% 
% For all details please refer to README.m
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence, for 
% personal and non-commercial use and research purpose. 

load(['ParamPSI','X',num2str(M),'X',num2str(N),'X',num2str(L),'01.mat'])
Do = D;
[M,N] = size(Do);
[M,L] = size(Y);    
alpha = 10^-7; % Fixed Step-size
IN = 100000; % Number of Iterations

%%% Cancelling the Mean value of Y

Y = double(Y) - ones(M,1)*mean(Y);

%%%%% Projected Subgradient 

c = sum(sum(abs(Y'*D)));
cost(1) = c;
tic
for i = 1 : IN
    SG = Y*sign(Y'*D);  % This can be replaced by Y*signrand(Y'*D);   
    D = D - alpha*SG;   
    D = ProjTF(D);
    D = ProjUNColBall(D);
    c = sum(sum(abs(Y'*D)));
    cost(i+1) = c;
    if mod(i,100) == 0, 
        i 
    end
end
toc
save(['ImageAOL',num2str(M),'X',num2str(N),'X',num2str(L),'.mat'],'D','Y','Do','cost')