% Synthetic Analysis Operator Recovery Test (Figure 3)

% This experiment may take long to run! You can reduce the number of trial or
% restrict different setting to reduce the computation time. 

% If you have Matlab parallel processing toolbox, you can uncomment
% "parfor" and comment the "for" term to accelerate the simulations.

% Constrained Analysis Operator Learning for Cosparse Signal Modelling
% Written by Mehrdad Yaghoobi, version 1.0                                    
%     
% Copyright 2013 Mehrdad Yaghoobi, Sangnam Nam, Remi Gribonval and Mike E. Davies
% 
% For all details please refer to README.m
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence, for 
% personal and non-commercial use and research purpose. 

M = 16; % Signal Space Dimension
N = 24; % Analysis Space Dimension
Ll = N*16*[1 2 4]; % Training Samples Population
T = 10; % Number of Trial
r = 2:7; % 1:M-1; % Cosparsity 
Eps = [0 1 10];

%%%% Exact Recovery Computation with Different Settings

% matlabpool(8); % 8 is the maximum number of workers in the pool

rr = length(r);
EEps = length(Eps);
LLl = length(Ll);
% parfor i = 1:rr*EEps*LLl
for i = 1:rr*EEps*LLl
    L = Ll(fix((i-1)/(EEps*rr))+1);
    j = mod(i-1,EEps*rr)+1;
    R = r(fix((j-1)/EEps)+1);
    eps = Eps(mod(j-1,EEps)+1);
    SubGPAOR(M,N,R,L,eps,T)            
end

% matlabpool close;

%%%% Plots of the Results

SAORShow(M,N,Ll,T,r,Eps)
