function [] = SAORShow(M,N,Ll,T,r,ep)
% Synthetic Analysis Operator Recovery Demonstration

% M = Signal space dimension
% N = Analysis space dimension
% r = Cosparsities (vector)
% Ll = Set of population of the training samples (vector)
% eps = Set of deviations of the starting operator from desired operator (vector)
% T = Number of trials

% Constrained Analysis Operator Learning for Cosparse Signal Modelling
% Written by Mehrdad Yaghoobi, version 1.0                                    
%     
% Copyright 2013 Mehrdad Yaghoobi, Sangnam Nam, Remi Gribonval and Mike E. Davies
% 
% For all details please refer to README.m
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence, for 
% personal and non-commercial use and research purpose. 

Tri = length(Ll);
rl = length(r);
epl = length(ep);
Err = zeros(epl,rl);
l = 1;

cd Solutions

for l = 1:Tri
    L = Ll(l);
    for i = 1:epl,
        eps = ep(i);
        for j = 1:rl,        
            R = r(j);
            load(['AOR',num2str(R),'X',num2str(M),'X',num2str(N),'X',num2str(L),'X',num2str(eps),'X',num2str(T),'v01.mat'])
            Err(i,j,l) = sum(err)/T;
        end
    end
end

cd ..

% clf

for l = 1:Tri    
    for i = 1:epl
%         subplot(Tri,epl,l+epl*(i-1))
        subplot(Tri,epl,i+epl*(l-1))
        hold on
%         bar(r ,Err(i,:,l));
        h = plot(r ,Err(i,:,l),'k');
        set(h,'LineWidth',2)
        grid on
        if i == 1,
            ylabel(['l = ',num2str(Ll(l))])
        end
        if l==1, 
            title(['\lambda = ',num2str(ep(i))])
        end    
        ax = axis;
%         axis([r(1)-.5 , r(rl)+.5, ax(3), ax(4)])
        axis([r(1)-.5 , r(rl)+.5, 0, 102])
    end
end