function B1 = ProjUNColBall(B)
% Projection onto the set of Uniformly Normalised Frames.
% The norm of each colum would be square root of the inverse of frame redundancy
% B = Input Frame
% B1 = Output Frame with Niformly Normalised columns

% Constrained Analysis Operator Learning for Cosparse Signal Modelling
% Written by Mehrdad Yaghoobi, version 1.0                                    
%     
% Copyright 2013 Mehrdad Yaghoobi, Sangnam Nam, Remi Gribonval and Mike E. Davies
% 
% For all details please refer to README.m
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence, for 
% personal and non-commercial use and research purpose. 

B1 = B;
[M,N] = size(B);
alpha = sqrt(M/N);
for ind = 1:N 
    B1(:,ind) = alpha*B1(:,ind)/sqrt(B1(:,ind)'*B1(:,ind));
end

