%%% Noise Aware Analysis Operator learning Demo %%%

% The Matlab codes in this package are the simulation codes of the paper:
%
% Constrained Overcomplete Analysis Operator Learning for Cosparse Signal Modelling by M. Yaghoobi, 
% S. Nam, R. Gribonval, M. Davies, accepted for publication in the IEEE Transaction on Signal Processing, 2012.
% http://arxiv.org/abs/1205.4133

% This demo is tested on Matlab R2011a running on the Linux platform and there is no guarantee to work with other settings.

% These codes have been written by Mehrdad Yaghoobi at the University of
% Edinburgh under the support of EU FP7 project SMALL, FET-Open grant number 225913, and the EPSRC project EP/J015180/1.

% 14/3/2013, version 0.3

%%% Installation %%%

% Extract the codes and add its address to the Matlab path.
% You need to have the Cropped Yale face database in your Matlab path. You can get the data from:
% http://vision.ucsd.edu/extyaleb/CroppedYaleBZip/CroppedYale.zip

%%% Structure of the codes

% The codes include three experiments about analysis operator learning in the noiseless (AOL) and noise-aware (NAAOL) settings as
% follows:

% 1- Exact recovery of a UNTF reference operator using the AOL to generate Figures 2 and 3 (Demo_BatchRecoveryFig2.m and Demo_BatchRecoveryFig3.m)

% 2- Learning some operators for the piecewise constant images with two different settings for the operators:
% a) full rank and b) rank deficient with DC as the null space (Demo_AOLforPSImageFullRank.m and Demo_AOLforPSImageRankDeficient.m)

% 3- Denoising Face Images using an L1-analysis formulation using the learned and TV operators to generate figures 12 and 13 (Demo_FaceImageDenoising.m)

%%% Updates %%%

% To get the most up to date code and the paper, please visit the following websites:

% http://www.see.ed.ac.uk/~s0574225/

% Copyright and license
             
% Copyright 2013 Mehrdad Yaghoobi*, Sangnam Nam^, Remi Gribonval' and Mike Evan Davies*
 
%                * University of Edinburgh, UK
%                ^ Aix-Marseille University, France
%                ' INRIA, Rennes, France

% If you use this code, please cite this article :

% "Constrained Overcomplete Analysis Operator Learning for Cosparse Signal Modelling", M. Yaghoobi, S. Nam, R. Gribonval, M. Davies, to appear in the IEEE Transaction on Signal Processing, 2012.   
                                                                                                
% This software is a free software distributed under the terms of the GNU Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can redistribute it and/or modify it under the terms of this licence, for personal and non-commercial use and research purpose.     
